;; Test performance of converting random generated numbers of various types
;; back and forth between string notation.
;; Note that this also depends on the performance of some operators like +,
;; random, = and <.
;; Also, this is silly since random generates different numbers every time.
;; Maybe use a loop that increments or something

(use numbers)

;; Gauche
;; (define assert identity)
;;
;; Racket
;; #lang racket

(define-syntax t
  (syntax-rules ()
    ((_ expr)
     (let lp ((i 0))
       (when (< i 100000)
         (let* ((num expr)
                (num2 (string->number (number->string num))))
           ;(assert (= num num2))
           (lp (+ i 1))))))))

(define s (make-string 100000 #\9))

(display "Reading a large bignum (dec):\n")

(time (let lp ((i 0))
        (string->number s)
        (when (< i 100)
          (lp (+ i 1)))))

(display "Reading a large bignum (hex):\n")

(time (let lp ((i 0))
        (string->number s 16)
        (when (< i 100)
          (lp (+ i 1)))))

(define num (string->number (make-string 100000 #\9)))

(display "Writing a large bignum (dec):\n")

(time (let lp ((i 0))
        (number->string num)
        (when (< i 100)
          (lp (+ i 1)))))

(display "Writing a large bignum (hex):\n")

(time (let lp ((i 0))
        (number->string num 16)
        (when (< i 100)
          (lp (+ i 1)))))
